function [O,S] = prepInput(targetPairs,feats)

nequalIdx = find(targetPairs(:,4)~=3);   % non-equal pairs
equalIdx = find(targetPairs(:,4)==3);    % equal pairs

% Forming the Ordered Set
O = zeros(length(nequalIdx),size(feats,1));
for o = 1:length(nequalIdx)
    
    currPair = targetPairs(nequalIdx(o),:);
    
    if currPair(4) == 1
        O(o,currPair(1)) = 1;
        O(o,currPair(2)) = -1;
    elseif currPair(4) == 2
        O(o,currPair(1)) = -1;
        O(o,currPair(2)) = 1;
    else
         fprintf('Error: Equal pair detected in Ordered Set!\n');
    end
    
end

% Forming the Similarity Set
S = zeros(length(equalIdx),size(feats,1));
for s = 1:length(equalIdx)
    
    currPair = targetPairs(equalIdx(s),:);
    
    if currPair(4) == 3
        S(s,currPair(1)) = 1;
        S(s,currPair(2)) = -1;
    else
         fprintf('Error: Non-equal pair detected in Similarity Set!\n');
    end
    
end
